/** @brief Example class for a differential equation model 

    The model is

    ???

    \tparam T a type representing time values
    \tparam N a type representing states and f-values
*/
template<class T, class N=T>
class Model
{
public:
  /** \brief export size_type */
  typedef std::size_t size_type;

  /** \brief export time_type */
  typedef T time_type;

  /** \brief export number_type */
  typedef N number_type;

  //! constructor stores parameter
  Model (const N& t_a_, const Vector<N>& u_a_, const int& i_)
    : t_a(t_a_), u_a(u_a_), i(i_)
  {}

  //! return number of componentes for the model
  std::size_t size () const
  {
    return 2;
  }

  //! set initial state including time value
  void initialize (T& t_a_, Vector<N>& x0) const
  {
    t_a_ = t_a;
    x0 = u_a;
  }

  //! model evaluation
  void f (const T& t, const Vector<N>& x, Vector<N>& result) const
  {
    // model for computing y0
    if (i==0){
      //***add Code here***
      //result[0] = ;
      //result[1] = ;
    }
    // model for computing Y0, Y1
    else{
      //***add Code here***
      //result[0] = ;
      //result[1] = ;
    }
  }

private:
  N t_a;
  Vector<N> u_a;
  int i; //switch between f(t) = f(t) and f(t) = 0
};
